package cache

import (
	"errors"
	"testing"
)

func TestNew(t *testing.T) {
	/*	if err := Init(WithRedis("127.0.0.1", 6379, "", "MyPassw0rd")); err != nil {
			t.Fatal(err)
		}

		type User struct {
			Name string `json:"name"`
			Age  int    `json:"age"`
		}

		if err := Default.Set(t.Context(), "zyp:haha", &User{
			Name: "cache",
			Age:  18,
		}); err != nil {
			t.Fatal(err)
		}

		s := Default.GetDelScan(t.Context(), "zyp:haha")
		u := new(User)

		if err := s.Scan(u); err != nil {
			t.Fatal(err)
		}

		t.Logf("%#v", *u)

		if err := Default.SetEx(t.Context(), "zyp:haha", &User{
			Name: "redis",
			Age:  2,
		}, time.Hour); err != nil {
			t.Fatal(err)
		}*/
}

func TestNoAuth(t *testing.T) {
	//if err := Init(WithRedis("10.125.1.28", 6379, "", "")); err != nil {
	//	t.Fatal(err)
	//}
	//
	//type User struct {
	//	Name string `json:"name"`
	//	Age  int    `json:"age"`
	//}
	//
	//if err := Default.Set(t.Context(), "zyp:haha", &User{
	//	Name: "cache",
	//	Age:  18,
	//}); err != nil {
	//	t.Fatal(err)
	//}
	//
	//s := Default.GetDelScan(t.Context(), "zyp:haha")
	//u := new(User)
	//
	//if err := s.Scan(u); err != nil {
	//	t.Fatal(err)
	//}
	//
	//t.Logf("%#v", *u)
	//
	//if err := Default.SetEx(t.Context(), "zyp:haha", &User{
	//	Name: "redis",
	//	Age:  2,
	//}, time.Hour); err != nil {
	//	t.Fatal(err)
	//}
}

func TestMemory(t *testing.T) {
	c, err := New(WithMemory())
	if err != nil {
		t.Fatal(err)
	}

	bs, err := c.Get(t.Context(), "haha")
	if err != nil {
		if !errors.Is(err, ErrorKeyNotFound) {
			t.Fatal(err)
		}

		t.Logf("key not found")
	}

	t.Logf("haha = %s", string(bs))

	if err = c.Set(t.Context(), "haha", "haha"); err != nil {
		t.Fatal(err)
	}

	if bs, err = c.Get(t.Context(), "haha"); err != nil {
		t.Fatal(err)
	}

	t.Logf("haha = %s", string(bs))
}
